-- Made by Porth @ Illidan-US Horde
-- Based on "Purge", which was written by Kynetix @ Kil'Jaden-US Alliance

function InterruptAndDispel_OnLoad(this)	
	SLASH_InterruptAndDispel1= "/iad";
	SlashCmdList["InterruptAndDispel"] = InterruptAndDispel_CommandParse;
	
	this:RegisterEvent("PLAYER_LOGIN");
	this:RegisterEvent("PLAYER_LOGOUT");
	this:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
end

function InterruptAndDispel_OnEvent(this, event, ...)	
	if (event == "PLAYER_LOGIN") then
		if (IAD_On == nil) then
			IAD_On = true
		end
		if (IAD_InterruptOn == nil) then
			IAD_InterruptOn = true
		end
		if (IAD_DispelOn == nil) then
			IAD_DispelOn = true
		end
		if (IAD_AnnounceTo == nil) then
			IAD_AnnounceTo = "SAY"
		end
	end
	
	if (event == "PLAYER_LOGOUT") then
		--IAD_On = IAD_On;
		--IAD_AnnounceTo = IAD_AnnounceTo;
		--IAD_InterruptOn = IAD_InterruptOn;
		--IAD_DispelOn = IAD_DispelOn;
		this:UnregisterEvent("PLAYER_LOGIN");
		this:UnregisterEvent("PLAYER_LOGOUT");
		this:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
	end
	

	local _, eventType, _, _, sourceName, _, _, _, targetName, _, _, sourceSpellID, _, _, spellId, spellName, schoolnumber = select(1, ...)
	local playerName = UnitName("player");
	
	if (event=="COMBAT_LOG_EVENT_UNFILTERED" and IAD_On == true) then
		if(eventType == "SPELL_INTERRUPT" and IAD_InterruptOn == true)  then
			if (sourceName == playerName) then
				SendChatMessage(GetSpellLink(spellId).." interrupted!",""..IAD_AnnounceTo.."")
			end
		end

		if(eventType == "SPELL_STOLEN" and IAD_DispelOn == true)  then
			if (sourceName == playerName) then
				SendChatMessage(GetSpellLink(spellId).." stolen!",""..IAD_AnnounceTo.."")
			end
		end

		if(eventType == "SPELL_DISPEL" and IAD_DispelOn == true)  then			
			if (sourceName == playerName) then
				SendChatMessage("Dispelled "..GetSpellLink(spellId)..".",""..IAD_AnnounceTo.."")
			end
		end
	end
end

function InterruptAndDispel_Message(message)
	DEFAULT_CHAT_FRAME:AddMessage("[InterruptAndDispel] " .. message, 1, 1, 1);
end

function InterruptAndDispel_CommandParse(parameterstring)
	local command = nil;
	local isOn = "";
	local intOn = "";
	local disOn = "";
	
	command = string.lower(parameterstring);
	if IAD_On then 
		isOn = "On"
	else
		isOn = "Off"
	end
	if IAD_InterruptOn then
		intOn = "On"
	else
		intOn = "Off"
	end
	if IAD_DispelOn then
		disOn = "On"
	else
		disOn = "Off"
	end

	if (command == 'off') then
		IAD_On = false
		isOn = "Off"
		InterruptAndDispel_Message('InterruptAndDispel is '..isOn);
	elseif (command == 'on') then
		IAD_On = true
		isOn = "On"
		InterruptAndDispel_Message('InterruptAndDispel is '..isOn);
	elseif (command == 'interrupton') then
		IAD_InterruptOn = true
		intOn = "On"
		InterruptAndDispel_Message('Interrupts is '..intOn);
	elseif (command == 'dispelon') then
		IAD_DispelOn = true
		disOn = "On"
		InterruptAndDispel_Message('Dispels is '..disOn);
	elseif (command == 'interruptoff') then
		IAD_InterruptOn = false
		intOn = "Off"
		InterruptAndDispel_Message('Interrupts is '..intOn);
	elseif (command == 'dispeloff') then
		IAD_DispelOn = false
		disOn = "Off"
		InterruptAndDispel_Message('Dispels is '..disOn);
	elseif (command == 'self') then
		IAD_AnnounceTo = "SELF"
		InterruptAndDispel_Message('Output is now on '..IAD_AnnounceTo);
	elseif (command == 'say') then
		IAD_AnnounceTo = "SAY"
		InterruptAndDispel_Message('Output is now on '..IAD_AnnounceTo);
	elseif (command == 'yell') then
		IAD_AnnounceTo = "YELL"
		InterruptAndDispel_Message('Output is now on '..IAD_AnnounceTo);
	elseif (command == 'party') then
		IAD_AnnounceTo = "PARTY"
		InterruptAndDispel_Message('Output is now on '..IAD_AnnounceTo);
	elseif (command == 'raid') then
		IAD_AnnounceTo = "RAID"
		InterruptAndDispel_Message('Output is now on '..IAD_AnnounceTo);
	elseif (command == 'bg') then
		IAD_AnnounceTo = "BATTLEGROUND"
		InterruptAndDispel_Message('Output is now on '..IAD_AnnounceTo);
	elseif (command == 'emote') then
		IAD_AnnounceTo = "EMOTE"
		InterruptAndDispel_Message('Output is now on '..IAD_AnnounceTo);
	elseif (command == 'instance') then
		IAD_AnnounceTo = "INSTANCE"
		InterruptAndDispel_Message('Output is now on '..IAD_AnnounceTo);
	elseif (command == 'current') then
		InterruptAndDispel_Message('InterruptAndDispel is "' .. isOn ..'".\nDispel announce is "' .. disOn .. '".\nInterrupt announce is "'.. intOn ..'".\nAnnouncing to: /'..string.lower(IAD_AnnounceTo))
	else
		InterruptAndDispel_Message('Commands are /iad (ex: /iad on) \non\noff\ninterrupton (Turns on the interrupt announcer)\ninterruptoff (And turns it off)\ndispelon (Turns on the dispel announcer)\ndispeloff\nself (Output only to self)\nsay (Output to /say)\nyell (Output to /y)\nparty (Output to /p)\nraid (Output to /r)\nbg (Output to /bg)\nemote\ninstance (Output to /i)\ncurrent (this tells you your current settings)')
	end

end